Index: serefpolicy-contrib-20140730/usbmuxd.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/usbmuxd.fc
+++ serefpolicy-contrib-20140730/usbmuxd.fc
@@ -1,3 +1,4 @@
 /usr/sbin/usbmuxd	--	gen_context(system_u:object_r:usbmuxd_exec_t,s0)
 
-/var/run/usbmuxd.*	gen_context(system_u:object_r:usbmuxd_var_run_t,s0)
+/var/run/usbmuxd.*	 	gen_context(system_u:object_r:usbmuxd_var_run_t,s0)
+/usr/lib/systemd/system/usbmuxd.*	--	gen_context(system_u:object_r:usbmuxd_unit_file_t,s0)
Index: serefpolicy-contrib-20140730/usbmuxd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/usbmuxd.if
+++ serefpolicy-contrib-20140730/usbmuxd.if
@@ -38,3 +38,66 @@ interface(`usbmuxd_stream_connect',`
 	files_search_pids($1)
 	stream_connect_pattern($1, usbmuxd_var_run_t, usbmuxd_var_run_t, usbmuxd_t)
 ')
+
+########################################
+## <summary>
+##	Execute usbmuxd server in the usbmuxd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`usbmuxd_systemctl',`
+	gen_require(`
+		type usbmuxd_t;
+		type usbmuxd_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 usbmuxd_unit_file_t:file read_file_perms;
+	allow $1 usbmuxd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, usbmuxd_t)
+')
+
+#####################################
+## <summary>
+##	All of the rules required to administrate
+##	an usbmuxd environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	The role to be allowed to manage the usbmuxd domain.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`usbmuxd_admin',`
+	gen_require(`
+		type usbmuxd_t,usbmuxd_var_run_t;
+		type usbmuxd_unit_file_t;
+	')
+
+	allow $1 usbmuxd_t:process { signal_perms };
+	ps_process_pattern($1, usbmuxd_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 usbmuxd_t:process ptrace;
+	')
+
+	allow $2 system_r;
+
+	files_list_pids($1)
+	admin_pattern($1, usbmuxd_var_run_t)
+
+	usbmuxd_systemctl($1)
+	admin_pattern($1, usbmuxd_unit_file_t)
+	allow $1 usbmuxd_unit_file_t:service all_service_perms;
+')
Index: serefpolicy-contrib-20140730/usbmuxd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/usbmuxd.te
+++ serefpolicy-contrib-20140730/usbmuxd.te
@@ -10,12 +10,16 @@ roleattribute system_r usbmuxd_roles;
 
 type usbmuxd_t;
 type usbmuxd_exec_t;
+init_system_domain(usbmuxd_t, usbmuxd_exec_t)
 application_domain(usbmuxd_t, usbmuxd_exec_t)
 role usbmuxd_roles types usbmuxd_t;
 
 type usbmuxd_var_run_t;
 files_pid_file(usbmuxd_var_run_t)
 
+type usbmuxd_unit_file_t;
+systemd_unit_file(usbmuxd_unit_file_t)
+
 ########################################
 #
 # Local policy
@@ -24,6 +28,7 @@ files_pid_file(usbmuxd_var_run_t)
 allow usbmuxd_t self:capability { kill setgid setuid };
 allow usbmuxd_t self:process { signal signull };
 allow usbmuxd_t self:fifo_file rw_fifo_file_perms;
+allow usbmuxd_t self:netlink_kobject_uevent_socket create_socket_perms;
 
 manage_dirs_pattern(usbmuxd_t, usbmuxd_var_run_t, usbmuxd_var_run_t)
 manage_files_pattern(usbmuxd_t, usbmuxd_var_run_t, usbmuxd_var_run_t)
@@ -38,6 +43,10 @@ dev_rw_generic_usb_dev(usbmuxd_t)
 
 auth_use_nsswitch(usbmuxd_t)
 
-miscfiles_read_localization(usbmuxd_t)
-
 logging_send_syslog_msg(usbmuxd_t)
+
+seutil_dontaudit_read_file_contexts(usbmuxd_t)
+
+optional_policy(`
+	virt_dontaudit_read_chr_dev(usbmuxd_t)
+')
Index: serefpolicy-contrib-20140730/userhelper.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/userhelper.fc
+++ serefpolicy-contrib-20140730/userhelper.fc
@@ -1,5 +1,10 @@
-/etc/security/console\.apps(/.*)?	gen_context(system_u:object_r:userhelper_conf_t,s0)
+#
+# /etc
+#
+/etc/security/console\.apps(/.*)?		gen_context(system_u:object_r:userhelper_conf_t,s0)
 
-/usr/bin/consolehelper	--	gen_context(system_u:object_r:consolehelper_exec_t,s0)
-
-/usr/sbin/userhelper	--	gen_context(system_u:object_r:userhelper_exec_t,s0)
+#
+# /usr
+#
+/usr/sbin/userhelper		--	gen_context(system_u:object_r:userhelper_exec_t,s0)
+/usr/bin/consolehelper		--	gen_context(system_u:object_r:consolehelper_exec_t,s0)
Index: serefpolicy-contrib-20140730/userhelper.if
===================================================================
--- serefpolicy-contrib-20140730.orig/userhelper.if
+++ serefpolicy-contrib-20140730/userhelper.if
@@ -1,4 +1,4 @@
-## <summary>A wrapper that helps users run system programs.</summary>
+## <summary>SELinux utility to run a shell with a new role</summary>
 
 #######################################
 ## <summary>
@@ -23,9 +23,9 @@
 #
 template(`userhelper_role_template',`
 	gen_require(`
-		attribute userhelper_type, consolehelper_type;
-		attribute_role userhelper_roles, consolehelper_roles;
-		type userhelper_exec_t, consolehelper_exec_t, userhelper_conf_t;
+		attribute userhelper_type;
+		type userhelper_exec_t, userhelper_conf_t;
+		class dbus send_msg;
 	')
 
 	########################################
@@ -33,64 +33,123 @@ template(`userhelper_role_template',`
 	# Declarations
 	#
 
-	type $1_consolehelper_t, consolehelper_type;
-	userdom_user_application_domain($1_consolehelper_t, consolehelper_exec_t)
-	
-	role consolehelper_roles types $1_consolehelper_t;
-	roleattribute $2 consolehelper_roles;
-
 	type $1_userhelper_t, userhelper_type;
 	userdom_user_application_domain($1_userhelper_t, userhelper_exec_t)
-
 	domain_role_change_exemption($1_userhelper_t)
 	domain_obj_id_change_exemption($1_userhelper_t)
 	domain_interactive_fd($1_userhelper_t)
 	domain_subj_id_change_exemption($1_userhelper_t)
-	
-	role userhelper_roles types $1_userhelper_t;
-	roleattribute $2 userhelper_roles;
+	role $2 types $1_userhelper_t;
 
 	########################################
 	#
-	# Consolehelper local policy
+	# Local policy
 	#
+	allow $1_userhelper_t self:capability { setuid setgid net_bind_service dac_override chown sys_tty_config };
+	allow $1_userhelper_t self:process ~{ ptrace setcurrent setexec setfscreate setrlimit execmem execstack execheap };
+	allow $1_userhelper_t self:process setexec;
+	allow $1_userhelper_t self:fd use;
+	allow $1_userhelper_t self:fifo_file rw_fifo_file_perms;
+	allow $1_userhelper_t self:shm create_shm_perms;
+	allow $1_userhelper_t self:sem create_sem_perms;
+	allow $1_userhelper_t self:msgq create_msgq_perms;
+	allow $1_userhelper_t self:msg { send receive };
+	allow $1_userhelper_t self:unix_dgram_socket create_socket_perms;
+	allow $1_userhelper_t self:unix_stream_socket create_stream_socket_perms;
+	allow $1_userhelper_t self:unix_dgram_socket sendto;
+	allow $1_userhelper_t self:unix_stream_socket connectto;
+	allow $1_userhelper_t self:sock_file read_sock_file_perms;
 
-	allow $1_consolehelper_t $3:unix_stream_socket connectto;
+	#Transition to the derived domain.
+	domtrans_pattern($3, userhelper_exec_t, $1_userhelper_t)
 
-	domtrans_pattern($3, consolehelper_exec_t, $1_consolehelper_t)
+	allow $1_userhelper_t userhelper_conf_t:dir rw_dir_perms;
+	rw_files_pattern($1_userhelper_t, userhelper_conf_t, userhelper_conf_t)
 
-	allow $3 $1_consolehelper_t:process { ptrace signal_perms };
-	ps_process_pattern($3, $1_consolehelper_t)
+	can_exec($1_userhelper_t, userhelper_exec_t)
 
-	auth_use_pam($1_consolehelper_t)
+	dontaudit $3 $1_userhelper_t:process signal;
 
-	optional_policy(`
-		dbus_connect_all_session_bus($1_consolehelper_t)
+	kernel_read_all_sysctls($1_userhelper_t)
+	kernel_getattr_debugfs($1_userhelper_t)
+	kernel_read_system_state($1_userhelper_t)
+
+	# Execute shells
+	corecmd_exec_shell($1_userhelper_t)
+	# By default, revert to the calling domain when a program is executed
+	corecmd_bin_domtrans($1_userhelper_t, $3)
 
-		optional_policy(`
-			userhelper_dbus_chat_all_consolehelper($3)
-		')
-	')
+	# Inherit descriptors from the current session.
+	domain_use_interactive_fds($1_userhelper_t)
+	# for when the user types "exec userhelper" at the command line
+	domain_sigchld_interactive_fds($1_userhelper_t)
+
+	dev_read_urand($1_userhelper_t)
+	# Read /dev directories and any symbolic links.
+	dev_list_all_dev_nodes($1_userhelper_t)
+
+	files_list_var_lib($1_userhelper_t)
+	# Read the /etc/security/default_type file
+	files_read_etc_files($1_userhelper_t)
+	# Read /var.
+	files_read_var_files($1_userhelper_t)
+	files_read_var_symlinks($1_userhelper_t)
+	# for some PAM modules and for cwd
+	files_search_home($1_userhelper_t)
+
+	fs_search_auto_mountpoints($1_userhelper_t)
+	fs_read_nfs_files($1_userhelper_t)
+	fs_read_nfs_symlinks($1_userhelper_t)
+
+	# Allow $1_userhelper to obtain contexts to relabel TTYs
+	selinux_get_fs_mount($1_userhelper_t)
+	selinux_validate_context($1_userhelper_t)
+	selinux_compute_access_vector($1_userhelper_t)
+	selinux_compute_create_context($1_userhelper_t)
+	selinux_compute_relabel_context($1_userhelper_t)
+	selinux_compute_user_contexts($1_userhelper_t)
+
+	# Read the devpts root directory.
+	term_list_ptys($1_userhelper_t)
+	# Relabel terminals.
+	term_relabel_all_ttys($1_userhelper_t)
+	term_relabel_all_ptys($1_userhelper_t)
+	# Access terminals.
+	term_use_all_ttys($1_userhelper_t)
+	term_use_all_ptys($1_userhelper_t)
 
-	########################################
-	#
-	# Userhelper local policy
-	#
+	auth_domtrans_chk_passwd($1_userhelper_t)
+	auth_manage_pam_pid($1_userhelper_t)
+	auth_manage_var_auth($1_userhelper_t)
+	auth_search_pam_console_data($1_userhelper_t)
+	auth_use_nsswitch($1_userhelper_t)
 
-	domtrans_pattern($3, userhelper_exec_t, $1_userhelper_t)
+	logging_send_syslog_msg($1_userhelper_t)
 
-	dontaudit $3 $1_userhelper_t:process signal;
+	# Inherit descriptors from the current session.
+	init_use_fds($1_userhelper_t)
+	# Write to utmp.
+	init_manage_utmp($1_userhelper_t)
+	init_pid_filetrans_utmp($1_userhelper_t)
 
-	corecmd_bin_domtrans($1_userhelper_t, $3)
 
-	auth_domtrans_chk_passwd($1_userhelper_t)
-	auth_use_nsswitch($1_userhelper_t)
+	seutil_read_config($1_userhelper_t)
+	seutil_read_default_contexts($1_userhelper_t)
 
+	# Allow $1_userhelper_t to transition to user domains.
 	userdom_bin_spec_domtrans_unpriv_users($1_userhelper_t)
 	userdom_entry_spec_domtrans_unpriv_users($1_userhelper_t)
 
+	ifdef(`distro_redhat',`
+		optional_policy(`
+			# Allow transitioning to rpm_t, for up2date
+			rpm_domtrans($1_userhelper_t)
+		')
+	')
+
 	optional_policy(`
 		tunable_policy(`! secure_mode',`
+			#if we are not in secure mode then we can transition to sysadm_t
 			sysadm_bin_spec_domtrans($1_userhelper_t)
 			sysadm_entry_spec_domtrans($1_userhelper_t)
 		')
@@ -99,7 +158,7 @@ template(`userhelper_role_template',`
 
 ########################################
 ## <summary>
-##	Search userhelper configuration directories.
+##	Search the userhelper configuration directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -118,7 +177,7 @@ interface(`userhelper_search_config',`
 ########################################
 ## <summary>
 ##	Do not audit attempts to search
-##	userhelper configuration directories.
+##	the userhelper configuration directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -136,28 +195,26 @@ interface(`userhelper_dontaudit_search_c
 
 ########################################
 ## <summary>
-##	Send and receive messages from
-##	consolehelper over dbus.
+##	Do not audit attempts to write
+##	the userhelper configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`userhelper_dbus_chat_all_consolehelper',`
+interface(`userhelper_dontaudit_write_config',`
 	gen_require(`
-		attribute consolehelper_type;
-		class dbus send_msg;
+		type userhelper_conf_t;
 	')
 
-	allow $1 consolehelper_type:dbus send_msg;
-	allow consolehelper_type $1:dbus send_msg;
+	dontaudit $1 userhelper_conf_t:file write;
 ')
 
 ########################################
 ## <summary>
-##	Use userhelper all userhelper file descriptors.
+##	Allow domain to use userhelper file descriptor.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -175,7 +232,7 @@ interface(`userhelper_use_fd',`
 
 ########################################
 ## <summary>
-##	Send child terminated signals to all userhelper.
+##	Allow domain to send sigchld to userhelper.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -206,10 +263,79 @@ interface(`userhelper_exec',`
 		type userhelper_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, userhelper_exec_t)
 ')
 
+#######################################
+## <summary>
+##	The role template for the consolehelper module.
+## </summary>
+## <desc>
+##	<p>
+##	This template creates a derived domains which are used
+##	for consolehelper applications.
+##	</p>
+## </desc>
+## <param name="role_prefix">
+##	<summary>
+##	The prefix of the user domain (e.g., user
+##	is the prefix for user_t).
+##	</summary>
+## </param>
+## <param name="user_role">
+##	<summary>
+##	The role associated with the user domain.
+##	</summary>
+## </param>
+## <param name="user_domain">
+##	<summary>
+##	The type of the user domain.
+##	</summary>
+## </param>
+#
+template(`userhelper_console_role_template',`
+	gen_require(`
+		type consolehelper_exec_t;
+		attribute consolehelper_domain;
+		class dbus send_msg;
+	')
+	type $1_consolehelper_t, consolehelper_domain;
+	domain_type($1_consolehelper_t)
+	domain_entry_file($1_consolehelper_t, consolehelper_exec_t)
+	role $2 types $1_consolehelper_t;
+
+	domtrans_pattern($3, consolehelper_exec_t, $1_consolehelper_t)
+
+	allow $3 $1_consolehelper_t:process signal;
+	allow $3 $1_consolehelper_t:dbus send_msg;
+	allow $1_consolehelper_t $3:dbus send_msg;
+	allow $1_consolehelper_t $3:unix_stream_socket connectto;
+
+	kernel_read_system_state($1_consolehelper_t)
+
+	auth_use_pam($1_consolehelper_t)
+
+	userdom_manage_tmp_role($2, $1_consolehelper_t)
+
+	optional_policy(`
+		dbus_connect_session_bus($1_consolehelper_t)
+	')
+
+	optional_policy(`
+		shutdown_run($1_consolehelper_t, $2)
+		shutdown_send_sigchld($3)
+	')
+
+	optional_policy(`
+		mock_run($1_consolehelper_t, $2)
+	')
+
+	optional_policy(`
+		xserver_run_xauth($1_consolehelper_t, $2)
+		xserver_read_xdm_pid($1_consolehelper_t)
+	')
+')
+
 ########################################
 ## <summary>
 ##	Execute the consolehelper program
Index: serefpolicy-contrib-20140730/userhelper.te
===================================================================
--- serefpolicy-contrib-20140730.orig/userhelper.te
+++ serefpolicy-contrib-20140730/userhelper.te
@@ -1,15 +1,12 @@
-policy_module(userhelper, 1.9.0)
+policy_module(userhelper, 1.8.1)
 
 ########################################
 #
 # Declarations
 #
 
-attribute consolehelper_type;
 attribute userhelper_type;
-
-attribute_role consolehelper_roles;
-attribute_role userhelper_roles;
+attribute consolehelper_domain;
 
 type userhelper_conf_t;
 files_config_file(userhelper_conf_t)
@@ -22,141 +19,77 @@ application_executable_file(consolehelpe
 
 ########################################
 #
-# Common consolehelper domain local policy
+# consolehelper local policy
 #
 
-allow consolehelper_type self:capability { setgid setuid dac_override };
-allow consolehelper_type self:process signal;
-allow consolehelper_type self:fifo_file rw_fifo_file_perms;
-allow consolehelper_type self:unix_stream_socket create_stream_socket_perms;
-allow consolehelper_type self:shm create_shm_perms;
+allow consolehelper_domain self:shm create_shm_perms;
+allow consolehelper_domain self:capability { setgid setuid dac_override sys_nice }; 
+allow consolehelper_domain self:process { signal_perms getsched setsched };
 
-dontaudit consolehelper_type userhelper_conf_t:file audit_access;
-read_files_pattern(consolehelper_type, userhelper_conf_t, userhelper_conf_t)
+allow consolehelper_domain  userhelper_conf_t:file audit_access;
+dontaudit consolehelper_domain  userhelper_conf_t:file write;
+read_files_pattern(consolehelper_domain, userhelper_conf_t, userhelper_conf_t)
 
-domain_use_interactive_fds(consolehelper_type)
+# Init script handling
+domain_use_interactive_fds(consolehelper_domain)
 
-kernel_read_system_state(consolehelper_type)
-kernel_read_kernel_sysctls(consolehelper_type)
+# internal communication is often done using fifo and unix sockets.
+allow consolehelper_domain self:fifo_file rw_fifo_file_perms;
+allow consolehelper_domain self:unix_stream_socket create_stream_socket_perms;
 
-corecmd_exec_bin(consolehelper_type)
+kernel_read_kernel_sysctls(consolehelper_domain)
 
-dev_getattr_all_chr_files(consolehelper_type)
-dev_dontaudit_list_all_dev_nodes(consolehelper_type)
+corecmd_exec_bin(consolehelper_domain)
 
-files_read_config_files(consolehelper_type)
-files_read_usr_files(consolehelper_type)
+dev_getattr_all_chr_files(consolehelper_domain)
+dev_dontaudit_list_all_dev_nodes(consolehelper_domain)
+dev_dontaudit_getattr_all(consolehelper_domain)
+fs_getattr_all_fs(consolehelper_domain)
+fs_getattr_all_dirs(consolehelper_domain)
 
-fs_getattr_all_dirs(consolehelper_type)
-fs_getattr_all_fs(consolehelper_type)
-fs_search_auto_mountpoints(consolehelper_type)
-files_search_mnt(consolehelper_type)
+files_read_config_files(consolehelper_domain)
 
-term_list_ptys(consolehelper_type)
+term_list_ptys(consolehelper_domain)
 
-auth_search_pam_console_data(consolehelper_type)
-auth_read_pam_pid(consolehelper_type)
+auth_search_pam_console_data(consolehelper_domain)
+auth_read_pam_pid(consolehelper_domain)
 
-miscfiles_read_localization(consolehelper_type)
-miscfiles_read_fonts(consolehelper_type)
+init_read_utmp(consolehelper_domain)
+init_telinit(consolehelper_domain)
 
-userhelper_exec(consolehelper_type)
+miscfiles_read_fonts(consolehelper_domain)
 
-userdom_use_user_terminals(consolehelper_type)
+userhelper_exec(consolehelper_domain)
 
-# might want to make this consolehelper_tmp_t
-userdom_manage_user_tmp_dirs(consolehelper_type)
-userdom_manage_user_tmp_files(consolehelper_type)
-userdom_tmp_filetrans_user_tmp(consolehelper_type, { dir file })
+userdom_use_user_ptys(consolehelper_domain)
+userdom_use_user_ttys(consolehelper_domain)
+userdom_read_user_home_content_files(consolehelper_domain)
+userdom_search_admin_dir(consolehelper_domain)
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_search_nfs(consolehelper_type)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_search_cifs(consolehelper_type)
+optional_policy(`
+	dbus_session_bus_client(consolehelper_domain)
+	optional_policy(`
+		devicekit_dbus_chat_disk(consolehelper_domain)
+	')
 ')
 
 optional_policy(`
-	shutdown_run(consolehelper_type, consolehelper_roles)
-	shutdown_signal(consolehelper_type)
+	gnome_read_gconf_home_files(consolehelper_domain)
 ')
 
 optional_policy(`
-	xserver_domtrans_xauth(consolehelper_type)
-	xserver_read_xdm_pid(consolehelper_type)
-	xserver_stream_connect(consolehelper_type)
+	xserver_read_home_fonts(consolehelper_domain)
+	xserver_stream_connect(consolehelper_domain)
+	xserver_admin_home_dir_filetrans_xauth(consolehelper_domain)
+	xserver_manage_user_xauth(consolehelper_domain)
 ')
 
-########################################
-#
-# Common userhelper domain local policy
-#
-
-allow userhelper_type self:capability { setuid setgid net_bind_service dac_override chown sys_tty_config };
-allow userhelper_type self:process ~{ ptrace setcurrent setfscreate setrlimit execmem execstack execheap };
-allow userhelper_type self:fd use;
-allow userhelper_type self:fifo_file rw_fifo_file_perms;
-allow userhelper_type self:shm create_shm_perms;
-allow userhelper_type self:sem create_sem_perms;
-allow userhelper_type self:msgq create_msgq_perms;
-allow userhelper_type self:msg { send receive };
-allow userhelper_type self:unix_dgram_socket sendto;
-allow userhelper_type self:unix_stream_socket { accept connectto listen };
-
-dontaudit userhelper_type userhelper_conf_t:file audit_access;
-read_files_pattern(userhelper_type, userhelper_conf_t, userhelper_conf_t)
-
-can_exec(userhelper_type, userhelper_exec_t)
-
-kernel_read_all_sysctls(userhelper_type)
-kernel_getattr_debugfs(userhelper_type)
-kernel_read_system_state(userhelper_type)
-
-corecmd_exec_shell(userhelper_type)
-
-domain_use_interactive_fds(userhelper_type)
-domain_sigchld_interactive_fds(userhelper_type)
-
-dev_read_urand(userhelper_type)
-dev_list_all_dev_nodes(userhelper_type)
-
-files_list_var_lib(userhelper_type)
-files_read_var_files(userhelper_type)
-files_read_var_symlinks(userhelper_type)
-files_search_home(userhelper_type)
-
-fs_getattr_all_fs(userhelper_type)
-fs_search_auto_mountpoints(userhelper_type)
-
-selinux_get_fs_mount(userhelper_type)
-selinux_validate_context(userhelper_type)
-selinux_compute_access_vector(userhelper_type)
-selinux_compute_create_context(userhelper_type)
-selinux_compute_relabel_context(userhelper_type)
-selinux_compute_user_contexts(userhelper_type)
-
-term_list_ptys(userhelper_type)
-term_relabel_all_ttys(userhelper_type)
-term_relabel_all_ptys(userhelper_type)
-term_use_all_ttys(userhelper_type)
-term_use_all_ptys(userhelper_type)
-
-auth_manage_pam_pid(userhelper_type)
-auth_manage_var_auth(userhelper_type)
-auth_search_pam_console_data(userhelper_type)
-
-init_use_fds(userhelper_type)
-init_manage_utmp(userhelper_type)
-init_pid_filetrans_utmp(userhelper_type)
-
-logging_send_syslog_msg(userhelper_type)
-
-miscfiles_read_localization(userhelper_type)
-
-seutil_read_config(userhelper_type)
-seutil_read_default_contexts(userhelper_type)
+tunable_policy(`use_nfs_home_dirs',`
+	files_search_mnt(consolehelper_domain)
+	fs_search_nfs(consolehelper_domain)
+')
 
-optional_policy(`
-	rpm_domtrans(userhelper_type)
+tunable_policy(`use_samba_home_dirs',`
+	files_search_mnt(consolehelper_domain)
+	fs_search_cifs(consolehelper_domain)
 ')
Index: serefpolicy-contrib-20140730/usernetctl.if
===================================================================
--- serefpolicy-contrib-20140730.orig/usernetctl.if
+++ serefpolicy-contrib-20140730/usernetctl.if
@@ -39,6 +39,7 @@ interface(`usernetctl_domtrans',`
 #
 interface(`usernetctl_run',`
 	gen_require(`
+		type usernetctl_t;
 		attribute_role usernetctl_roles;
 	')
 
Index: serefpolicy-contrib-20140730/usernetctl.te
===================================================================
--- serefpolicy-contrib-20140730.orig/usernetctl.te
+++ serefpolicy-contrib-20140730/usernetctl.te
@@ -6,12 +6,12 @@ policy_module(usernetctl, 1.7.0)
 #
 
 attribute_role usernetctl_roles;
+roleattribute system_r usernetctl_roles;
 
 type usernetctl_t;
 type usernetctl_exec_t;
 application_domain(usernetctl_t, usernetctl_exec_t)
 domain_interactive_fd(usernetctl_t)
-role usernetctl_roles types usernetctl_t;
 
 ########################################
 #
@@ -40,7 +40,6 @@ files_exec_etc_files(usernetctl_t)
 files_read_etc_runtime_files(usernetctl_t)
 files_list_pids(usernetctl_t)
 files_list_home(usernetctl_t)
-files_read_usr_files(usernetctl_t)
 
 fs_search_auto_mountpoints(usernetctl_t)
 
@@ -48,18 +47,14 @@ auth_use_nsswitch(usernetctl_t)
 
 logging_send_syslog_msg(usernetctl_t)
 
-miscfiles_read_localization(usernetctl_t)
-
 seutil_read_config(usernetctl_t)
 
+sysnet_read_config(usernetctl_t)
+
 sysnet_run_ifconfig(usernetctl_t, usernetctl_roles)
 sysnet_run_dhcpc(usernetctl_t, usernetctl_roles)
 
-userdom_use_user_terminals(usernetctl_t)
-
-optional_policy(`
-	consoletype_run(usernetctl_t, usernetctl_roles)
-')
+userdom_use_inherited_user_terminals(usernetctl_t)
 
 optional_policy(`
 	hostname_exec(usernetctl_t)
@@ -74,5 +69,9 @@ optional_policy(`
 ')
 
 optional_policy(`
+	nis_use_ypbind(usernetctl_t)
+')
+
+optional_policy(`
 	ppp_run(usernetctl_t, usernetctl_roles)
 ')
Index: serefpolicy-contrib-20140730/uucp.if
===================================================================
--- serefpolicy-contrib-20140730.orig/uucp.if
+++ serefpolicy-contrib-20140730/uucp.if
@@ -90,11 +90,6 @@ interface(`uucp_domtrans_uux',`
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
 ## <rolecap/>
 #
 interface(`uucp_admin',`
@@ -104,14 +99,13 @@ interface(`uucp_admin',`
 		type uucpd_var_run_t, uucpd_initrc_exec_t;
 	')
 
-	init_labeled_script_domtrans($1, uucpd_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 uucpd_initrc_exec_t system_r;
-	allow $2 system_r;
-
-	allow $1 uucpd_t:process { ptrace signal_perms };
+	allow $1 uucpd_t:process signal_perms;
 	ps_process_pattern($1, uucpd_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 uucpd_t:process ptrace;
+	')
+
 	logging_list_logs($1)
 	admin_pattern($1, uucpd_log_t)
 
Index: serefpolicy-contrib-20140730/uucp.te
===================================================================
--- serefpolicy-contrib-20140730.orig/uucp.te
+++ serefpolicy-contrib-20140730/uucp.te
@@ -31,7 +31,7 @@ type uucpd_ro_t;
 files_type(uucpd_ro_t)
 
 type uucpd_spool_t;
-files_type(uucpd_spool_t)
+files_spool_file(uucpd_spool_t)
 
 type uucpd_log_t;
 logging_log_file(uucpd_log_t)
@@ -84,15 +84,20 @@ kernel_read_kernel_sysctls(uucpd_t)
 kernel_read_system_state(uucpd_t)
 kernel_read_network_state(uucpd_t)
 
-corenet_all_recvfrom_unlabeled(uucpd_t)
 corenet_all_recvfrom_netlabel(uucpd_t)
 corenet_tcp_sendrecv_generic_if(uucpd_t)
 corenet_tcp_sendrecv_generic_node(uucpd_t)
+corenet_udp_sendrecv_generic_node(uucpd_t)
+corenet_tcp_sendrecv_all_ports(uucpd_t)
+corenet_udp_sendrecv_all_ports(uucpd_t)
 
 corenet_sendrecv_ssh_client_packets(uucpd_t)
 corenet_tcp_connect_ssh_port(uucpd_t)
 corenet_tcp_sendrecv_ssh_port(uucpd_t)
 
+corenet_tcp_bind_uucpd_port(uucpd_t)
+corenet_tcp_connect_uucpd_port(uucpd_t)
+
 corecmd_exec_bin(uucpd_t)
 corecmd_exec_shell(uucpd_t)
 
@@ -110,7 +115,7 @@ auth_use_nsswitch(uucpd_t)
 
 logging_send_syslog_msg(uucpd_t)
 
-miscfiles_read_localization(uucpd_t)
+mta_send_mail(uucpd_t)
 
 optional_policy(`
 	cron_system_entry(uucpd_t, uucpd_exec_t)
@@ -125,10 +130,6 @@ optional_policy(`
 ')
 
 optional_policy(`
-	mta_send_mail(uucpd_t)
-')
-
-optional_policy(`
 	ssh_exec(uucpd_t)
 ')
 
@@ -160,10 +161,15 @@ auth_use_nsswitch(uux_t)
 logging_search_logs(uux_t)
 logging_send_syslog_msg(uux_t)
 
-miscfiles_read_localization(uux_t)
-
 optional_policy(`
 	mta_send_mail(uux_t)
 	mta_read_queue(uux_t)
+')
+
+optional_policy(`
 	sendmail_dontaudit_rw_unix_stream_sockets(uux_t)
 ')
+
+optional_policy(`
+	postfix_rw_inherited_master_pipes(uux_t)
+')
Index: serefpolicy-contrib-20140730/uuidd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/uuidd.if
+++ serefpolicy-contrib-20140730/uuidd.if
@@ -148,11 +148,12 @@ interface(`uuidd_read_pid_files',`
 #
 interface(`uuidd_stream_connect_manager',`
 	gen_require(`
-		type uuidd_t, uuidd_var_run_t;
+		type uuidd_t, uuidd_var_run_t, uuidd_var_lib_t;
 	')
 
 	files_search_pids($1)
 	stream_connect_pattern($1, uuidd_var_run_t, uuidd_var_run_t, uuidd_t)
+	stream_connect_pattern($1, uuidd_var_lib_t, uuidd_var_lib_t, uuidd_t)
 ')
 
 ########################################
@@ -180,6 +181,9 @@ interface(`uuidd_admin',`
 
 	allow $1 uuidd_t:process signal_perms;
 	ps_process_pattern($1, uuidd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 uuidd_t:process ptrace;
+	')
 
 	uuidd_initrc_domtrans($1)
 	domain_system_change_exemption($1)
Index: serefpolicy-contrib-20140730/uuidd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/uuidd.te
+++ serefpolicy-contrib-20140730/uuidd.te
@@ -42,6 +42,4 @@ dev_read_urand(uuidd_t)
 
 domain_use_interactive_fds(uuidd_t)
 
-files_read_etc_files(uuidd_t)
 
-miscfiles_read_localization(uuidd_t)
Index: serefpolicy-contrib-20140730/uwimap.te
===================================================================
--- serefpolicy-contrib-20140730.orig/uwimap.te
+++ serefpolicy-contrib-20140730/uwimap.te
@@ -37,7 +37,6 @@ kernel_read_kernel_sysctls(imapd_t)
 kernel_list_proc(imapd_t)
 kernel_read_proc_symlinks(imapd_t)
 
-corenet_all_recvfrom_unlabeled(imapd_t)
 corenet_all_recvfrom_netlabel(imapd_t)
 corenet_tcp_sendrecv_generic_if(imapd_t)
 corenet_tcp_sendrecv_generic_node(imapd_t)
@@ -56,8 +55,6 @@ dev_read_urand(imapd_t)
 
 domain_use_interactive_fds(imapd_t)
 
-files_read_etc_files(imapd_t)
-
 fs_getattr_all_fs(imapd_t)
 fs_search_auto_mountpoints(imapd_t)
 
@@ -65,8 +62,6 @@ auth_domtrans_chk_passwd(imapd_t)
 
 logging_send_syslog_msg(imapd_t)
 
-miscfiles_read_localization(imapd_t)
-
 sysnet_dns_name_resolve(imapd_t)
 
 userdom_dontaudit_use_unpriv_user_fds(imapd_t)
Index: serefpolicy-contrib-20140730/varnishd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/varnishd.if
+++ serefpolicy-contrib-20140730/varnishd.if
@@ -153,12 +153,16 @@ interface(`varnishd_manage_log',`
 #
 interface(`varnishd_admin_varnishlog',`
 	gen_require(`
+		type varnishd_t;
 		type varnishlog_t, varnishlog_initrc_exec_t, varnishlog_log_t;
 		type varnishlog_var_run_t;
 	')
 
-	allow $1 varnishlog_t:process { ptrace signal_perms };
+	allow $1 varnishlog_t:process signal_perms;
 	ps_process_pattern($1, varnishlog_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 varnishd_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, varnishlog_initrc_exec_t)
 	domain_system_change_exemption($1)
@@ -196,9 +200,13 @@ interface(`varnishd_admin',`
 		type varnishd_initrc_exec_t;
 	')
 
-	allow $1 varnishd_t:process { ptrace signal_perms };
+	allow $1 varnishd_t:process signal_perms;
 	ps_process_pattern($1, varnishd_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 varnishd_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, varnishd_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 varnishd_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/varnishd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/varnishd.te
+++ serefpolicy-contrib-20140730/varnishd.te
@@ -21,7 +21,7 @@ type varnishd_initrc_exec_t;
 init_script_file(varnishd_initrc_exec_t)
 
 type varnishd_etc_t;
-files_type(varnishd_etc_t)
+files_config_file(varnishd_etc_t)
 
 type varnishd_tmp_t;
 files_tmp_file(varnishd_tmp_t)
@@ -43,16 +43,16 @@ type varnishlog_var_run_t;
 files_pid_file(varnishlog_var_run_t)
 
 type varnishlog_log_t;
-files_type(varnishlog_log_t)
+logging_log_file(varnishlog_log_t)
 
 ########################################
 #
 # Local policy
 #
 
-allow varnishd_t self:capability { kill dac_override ipc_lock setuid setgid };
+allow varnishd_t self:capability { kill dac_override ipc_lock setuid setgid chown fowner };
 dontaudit varnishd_t self:capability sys_tty_config;
-allow varnishd_t self:process signal;
+allow varnishd_t self:process { execmem signal };
 allow varnishd_t self:fifo_file rw_fifo_file_perms;
 allow varnishd_t self:tcp_socket { accept listen };
 
@@ -103,15 +103,13 @@ corenet_tcp_sendrecv_varnishd_port(varni
 
 dev_read_urand(varnishd_t)
 
-files_read_usr_files(varnishd_t)
-
 fs_getattr_all_fs(varnishd_t)
 
 auth_use_nsswitch(varnishd_t)
 
 logging_send_syslog_msg(varnishd_t)
 
-miscfiles_read_localization(varnishd_t)
+sysnet_read_config(varnishd_t)
 
 tunable_policy(`varnishd_connect_any',`
 	corenet_sendrecv_all_client_packets(varnishd_t)
